## winexe 1.00.1

=== source4/Makefile ===
#!gmake
# The Samba 4 Makefile.
# This file is *NOT* autogenerated.
#
.DEFAULT_GOAL := all

default: all

include mkconfig.mk

pidldir := $(srcdir)/../pidl

basedir = $(prefix)
swatdir = $(datadir)/swat
setupdir = $(datadir)/setup
ncalrpcdir = $(localstatedir)/ncalrpc
shliboutputdir = $(builddir)/bin/shared

BNLD = $(LD)
BNLD_FLAGS = $(LDFLAGS) $(SYS_LDFLAGS)

HOSTCC_FLAGS = -D_SAMBA_HOSTCC_ $(CFLAGS)
HOSTLD_FLAGS = $(LDFLAGS) $(SYS_LDFLAGS)

$(srcdir)/version.h: $(srcdir)/VERSION
	@$(SHELL) script/mkversion.sh VERSION $(srcdir)/version.h $(srcdir)/

ifneq ($(automatic_dependencies),yes)
ALL_PREDEP = basics
.NOTPARALLEL:
endif

regen_version::
	@$(SHELL) script/mkversion.sh VERSION $(srcdir)/version.h $(srcdir)/

clean_pch::
	@echo "Removing precompiled headers"
	@-rm -f include/includes.h.gch

pch:: clean_pch include/includes.h.gch

.DEFAULT_GOAL := all

ifneq ($(automatic_dependencies),yes)
ALL_PREDEP = basics
.NOTPARALLEL:
endif

base_srcdirs = $(srcdir) ../librpc/ ../lib/ ../libcli ../libgpo ../nsswitch ../libds

include $(srcdir)/build/make/rules.mk
include $(srcdir)/build/make/python.mk
zlibsrcdir := ../lib/zlib
dynconfigsrcdir := dynconfig
heimdalsrcdir := heimdal
dsdbsrcdir := dsdb
smbdsrcdir := smbd
clustersrcdir := cluster
libnetsrcdir := libnet
authsrcdir := auth
nsswitchsrcdir := ../nsswitch
libwbclientsrcdir := ../nsswitch/libwbclient
libsrcdir := lib
libsocketsrcdir := lib/socket
libcharsetsrcdir := ../lib/util/charset
ldb_sambasrcdir := lib/ldb-samba
tdbsrcdir := ../lib/tdb
ldbsrcdir := lib/ldb
libtlssrcdir := lib/tls
libregistrysrcdir := lib/registry
smbreadlinesrcdir := lib/smbreadline
libmessagingsrcdir := lib/messaging
libteventsrcdir := ../lib/tevent
libeventssrcdir := lib/events
libcmdlinesrcdir := lib/cmdline
poptsrcdir := ../lib/popt
socketwrappersrcdir := ../lib/socket_wrapper
nsswrappersrcdir := ../lib/nss_wrapper
uidwrappersrcdir := ../lib/uid_wrapper
appwebsrcdir := lib/appweb
libstreamsrcdir := lib/stream
libutilsrcdir := ../lib/util
libtdrsrcdir := ../lib/tdr
libcryptosrcdir := ../lib/crypto
libtorturesrcdir := ../lib/torture
smb_serversrcdir := smb_server
libcompressionsrcdir := ../lib/compression
libgencachesrcdir := lib
paramsrcdir := param
rpc_serversrcdir := rpc_server
ldap_serversrcdir := ldap_server
web_serversrcdir := web_server
winbindsrcdir := winbind
nbt_serversrcdir := nbt_server
wrepl_serversrcdir := wrepl_server
cldap_serversrcdir := cldap_server
utilssrcdir := utils
clientsrcdir := client
torturesrcdir := torture
ntvfssrcdir := ntvfs
ntptrsrcdir := ntptr
librpcsrcdir := librpc
libclisrcdir := libcli
libclicommonsrcdir := ../libcli
libclinbtsrcdir := ../libcli/nbt
pyscriptsrcdir := $(srcdir)/scripting/python
kdcsrcdir := kdc
ntp_signdsrcdir := ntp_signd
wmisrcdir := lib/wmi
tallocsrcdir := ../lib/talloc
comsrcdir := $(srcdir)/lib/com
libgpodir := libgpo

include data.mk

$(DESTDIR)$(bindir)/%: scripting/bin/% installdirs
	@mkdir -p $(@D)
	@echo Installing $(@F) as $@
	@if test -f $@; then echo -n ""; rm -f $@.old; mv $@ $@.old; fi
	@cp $< $@
	@chmod $(INSTALLPERMS) $@

pythonmods:: $(PYTHON_PYS) $(PYTHON_SO)

DEP_FILES = $(patsubst %.ho,%.hd,$(patsubst %.o,%.d,$(ALL_OBJS))) \
		   include/includes.d

ifeq ($(automatic_dependencies),yes)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),realdistclean)
ifneq ($(SKIP_DEP_FILES),yes)
-include $(DEP_FILES)
endif
endif
endif
endif

ifneq ($(SKIP_DEP_FILES),yes)
clean::
	@echo Removing dependency files
	@find . -name '*.d' -o -name '*.hd' | xargs rm -f
endif
else
include $(srcdir)/static_deps.mk
endif

clean::
	@find $(base_srcdirs) -name '*.o' -o -name '*.ho' | xargs rm -f

PUBLIC_HEADERS += ./version.h

libraries:: $(STATIC_LIBS) $(SHARED_LIBS)
modules:: $(PLUGINS)
headers:: $(PUBLIC_HEADERS)
manpages:: $(MANPAGES)
all:: showflags $(ALL_PREDEP) binaries modules pythonmods libraries headers
everything:: all

LD_LIBPATH_OVERRIDE = $(LIB_PATH_VAR)=$(shliboutputdir):$$$(LIB_PATH_VAR)

# 'make testsuite' creates all binaries which are
# needed by samba3's 'make test' and the build-farm
# scripts use that it as fallback in case
# 'make everything' fails
testsuite:: bin/smbclient bin/cifsdd bin/smbtorture bin/nmblookup

showlayout:: 
	@echo 'Samba will be installed into:'
	@echo '  basedir:     $(basedir)'
	@echo '  bindir:      $(bindir)'
	@echo '  sbindir:     $(sbindir)'
	@echo '  libdir:      $(libdir)'
	@echo '  modulesdir:  $(modulesdir)'
	@echo '  includedir:  $(includedir)'
	@echo '  vardir:      $(localstatedir)'
	@echo '  privatedir:  $(privatedir)'
	@echo '  piddir:      $(piddir)'
	@echo '  lockdir:     $(lockdir)'
	@echo '  logfilebase: $(logfilebase)'
	@echo '  setupdir:    $(setupdir)'
	@echo '  swatdir:     $(swatdir)'
	@echo '  mandir:      $(mandir)'
	@echo '  datadir:     $(datadir)'
	@echo '  winbindd_socket_dir:  $(winbindd_socket_dir)'
	@echo '  ntp_signd_socket_dir:  $(ntp_signd_socket_dir)'

showflags::
	@echo '  srcdir     = $(srcdir)'
	@echo '  builddir   = $(builddir)'

# The permissions to give the executables
INSTALLPERMS = 0755

install:: showlayout everything installbin installsbin installdat installmisc \
	      installlib installheader installpc installplugins

# DESTDIR is used here to prevent packagers wasting their time
# duplicating the Makefile. Remove it and you will have the privilege
# of packaging each samba release for multiple versions of multiple
# distributions and operating systems, or at least supplying patches
# to all the packaging files required for this, prior to committing
# the removal of DESTDIR. Do not remove it even though you think it
# is not used.

installdirs::
	@$(SHELL) $(srcdir)/script/installdirs.sh \
		$(DESTDIR)$(basedir) \
		$(DESTDIR)$(bindir) \
		$(DESTDIR)$(sbindir) \
		$(DESTDIR)$(libdir) \
		$(DESTDIR)$(modulesdir) \
		$(DESTDIR)$(modulesdir)/ldb \
		$(DESTDIR)$(mandir) \
		$(DESTDIR)$(localstatedir) \
		$(DESTDIR)$(localstatedir)/lib \
		$(DESTDIR)$(localstatedir)/run \
		$(DESTDIR)$(privatedir) \
		$(DESTDIR)$(datadir) \
		$(DESTDIR)$(piddir) \
		$(DESTDIR)$(lockdir) \
		$(DESTDIR)$(logfilebase) \
		$(DESTDIR)$(privatedir)/tls \
		$(DESTDIR)$(includedir) \
		$(DESTDIR)$(pkgconfigdir) \
		$(DESTDIR)$(sysconfdir)

installbin:: installdirs

installplugins::

installlib:: $(SHARED_LIBS) $(STATIC_LIBS) installdirs
	@$(SHELL) $(srcdir)/script/installlib.sh $(DESTDIR)$(libdir) "$(SHLIBEXT)" $(SHARED_LIBS) 
	#@$(SHELL) $(srcdir)/script/installlib.sh $(DESTDIR)$(libdir) "$(STLIBEXT)" $(STATIC_LIBS)

installheader:: headers installdirs
	@srcdir=$(srcdir) builddir=$(builddir) $(PERL) $(srcdir)/script/installheader.pl $(DESTDIR)$(includedir) $(PUBLIC_HEADERS)

installdat:: installdirs
	@$(SHELL) $(srcdir)/script/installdat.sh $(DESTDIR)$(datadir) $(srcdir)

installman:: manpages installdirs
	@$(SHELL) $(srcdir)/script/installman.sh $(DESTDIR)$(mandir) $(MANPAGES)

installmisc:: installdirs
	@$(SHELL) $(srcdir)/script/installmisc.sh $(srcdir) $(DESTDIR)$(setupdir) $(DESTDIR)$(bindir) $(DESTDIR)$(sbindir) $(pythondir)

installpc:: installdirs
	@$(SHELL) $(srcdir)/script/installpc.sh $(builddir) $(DESTDIR)$(pkgconfigdir) $(PC_FILES)

uninstall:: uninstallbin uninstallsbin uninstalldat uninstallmisc uninstalllib uninstallheader \
			uninstallman uninstallpc uninstallplugins

uninstallmisc::
	@echo "Removing MISC files"
	@rm -rf $(DESTDIR)$(setupdir)/*

$(DESTDIR)$(bindir)/%: bin/% installdirs
	@mkdir -p $(@D)
	@echo Installing $(@F) as $@
	@if test -f $@; then echo -n ""; rm -f $@.old; mv $@ $@.old; fi
	@cp $< $@
	@chmod $(INSTALLPERMS) $@

$(DESTDIR)$(sbindir)/%: bin/% installdirs
	@mkdir -p $(@D)
	@echo Installing $(@F) as $@
	@if test -f $@; then echo -n ""; rm -f $@.old; mv $@ $@.old; fi
	@cp $< $@
	@chmod $(INSTALLPERMS) $@

uninstalldat::
	@echo "Removing DAT files"
	@rm -fr $(DESTDIR)$(datadir)/*

uninstallbin::

uninstalllib::
	@echo "Removing libraries"
	@$(SHELL) $(srcdir)/script/uninstalllib.sh $(DESTDIR)$(libdir) $(SHARED_LIBS)

uninstallheader::
	@echo "Removing headers"
	@rm -fr $(DESTDIR)$(includedir)/*

uninstallman::
	@echo "Removing manpages"
	@$(SHELL) $(srcdir)/script/uninstallman.sh $(DESTDIR)$(mandir) $(MANPAGES)

uninstallplugins::

uninstallpc::
	@echo "Removing package configurations"
	@cd $(DESTDIR)$(pkgconfigdir); rm -f $(notdir $(PC_FILES))

config.status:
	@echo "config.status does not exist. Please run ./configure."
	@/bin/false

data.mk: config.status $(MK_FILES)
	./config.status

testcov-html:: 

include $(pidldir)/config.mk
selftestdir := $(srcdir)/../selftest
include $(srcdir)/selftest/config.mk

showflags::
	@echo '  pwd        = '`/bin/pwd`

=== source4/winexe/winexesvc/Makefile ===
CFLAGS=-mno-cygwin -Os
LDFLAGS=-mno-cygwin -s -Os

CC_WIN32 := $(shell bash -c 'which {i386,i586}-{mingw32,mingw32msvc}-gcc')
CC_WIN64 := $(shell bash -c 'which {x86_64,amd64}-{mingw32,mingw32msvc}-gcc')

all: winexesvc32_exe.c winexesvc64_exe.c

winexesvc32.exe: winexesvc32.o service32.o
	$(CC_WIN32) $(LDFLAGS) -o $@ $^

winexesvc64.exe: winexesvc64.o service64.o
	$(CC_WIN64) $(LDFLAGS) -o $@ $^

%32.o: %.c
	$(CC_WIN32) -c $(CPPFLAGS) $(CFLAGS) -o $@ $^

%64.o: %.c
	$(CC_WIN64) -c $(CPPFLAGS) $(CFLAGS) -o $@ $^

winexesvc32_exe.c: winexesvc32.exe bin2c.exe
	./bin2c.exe winexesvc32_exe winexesvc32.exe > $@

winexesvc64_exe.c: winexesvc64.exe bin2c.exe
	./bin2c.exe winexesvc64_exe winexesvc64.exe > $@

bin2c.exe: bin2c.c
	gcc -s -o $@ $^

clean:
	-@rm *.exe *.o *_exe.c

## winexe 1.00

=== debian/changelog ===
winexe (1.00-1) eole-2.4-unstable; urgency=low

  * UNRELEASED

 -- Daniel Dehennin <daniel.dehennin@ac-dijon.fr>  Thu, 13 Nov 2014 11:32:23 +0100

=== debian/control ===
Source: winexe
Section: net
Priority: extra
Maintainer: Équipe EOLE <eole@ac-dijon.fr>
XSBC-Original-Maintainer: Thomas Hood <jdthood@gmail.com>
Build-Depends: debhelper (>= 8), autoconf (>= 2.53), python (>= 2.3), python-dev
Homepage: http://sourceforge.net/projects/winexe/
Vcs-Git: https://dev-eole.ac-dijon.fr/git/winexe.git
Vcs-Browser: https://dev-eole.ac-dijon.fr/projects/winexe/repository
XSBC-Original-Vcs-Git: git://winexe.git.sourceforge.net/gitroot/winexe/winexe
XSBC-Original-Vcs-Browser: http://winexe.git.sourceforge.net/git/gitweb-index.cgi
Standards-Version: 3.9.4.0

Package: winexe
Architecture: any
Depends: ${misc:Depends}
Description: Remote Windows command executor
 This package contains the winexe program which allows
 the user to execute arbitrary cmd.exe commands on a remote
 Windows machine.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=source4

override_dh_auto_configure:
	cd source4 && ./autogen.sh && ./configure --prefix=/usr --enable-fhs

override_dh_auto_build:
	cd source4 && make basics idl bin/winexe

override_dh_auto_test override_dh_usrlocal override_dh_installinit override_dh_auto_install:
	:

## winexe 1.1~20140107

=== debian/changelog ===
winexe (1.1~20140107-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:41:10 +0200

winexe (1.1~20140107-0kali18) kali-dev; urgency=medium

  * Workaround build failure for armel

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 26 Jun 2023 21:56:39 +0700

winexe (1.1~20140107-0kali17) kali-dev; urgency=medium

  * Build-Depends += libkeyutils-dev

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 26 Jun 2023 16:03:17 +0700

winexe (1.1~20140107-0kali16) kali-dev; urgency=medium

  * Add a patch to remove whitespace in README

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 19 Apr 2023 09:30:42 +0200

winexe (1.1~20140107-0kali15) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Update standards version to 4.6.1, no changes needed.
  * Add RFP bugs in 1.1~20130620-0kali1.
  * Update lintian override info to new format on line 4.
  * Update standards version to 4.6.2, no changes needed.

  [ Steev Klimaszewski ]
  * d/watch: Update to use sourceforge not debian redirector.
  * Update lintian overrides.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Sun, 09 Apr 2023 22:36:10 -0500

winexe (1.1~20140107-0kali14) kali-dev; urgency=medium

  * Add smoke test

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 26 Apr 2022 07:54:15 +0700

winexe (1.1~20140107-0kali13) kali-experimental; urgency=medium

  [ Ben Wilson ]
  * Update email address

  [ Arnaud Rebillout ]
  * Build-Depends += bison, flex
  * Build-Depends += python3-markdown
  * Build-Depends += python3-dnspython
  * Build-Depends += libjson-perl
  * d/rules: Use more variables for readability
  * d/rules: Drop line that has no effect
  * d/rules: Prevent random ordering of heimdal headers
  * d/rules: Drop systemd fix, not needed anymore
  * d/rules: Cosmetics, use spaces in assignments
  * Update 'dropped-headers' patch for samba libraries that were renamed
  * Add patch to update cli_credentials_set_kerberos_state()

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 25 Apr 2022 17:43:05 +0700

winexe (1.1~20140107-0kali12) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Repository.
  * Update renamed lintian tag names in lintian overrides.

  [ Sophie Brun ]
  * Add missing build-dep libdbus-1-dev
  * Update debian/watch to latest version 4
  * Bump Standards-Version to 4.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 07 Dec 2020 15:22:28 +0100

winexe (1.1~20140107-0kali11) kali-dev; urgency=medium

  * Add missing build-dep: libparse-yapp-perl

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 17 Jul 2020 10:49:08 +0200

winexe (1.1~20140107-0kali10) kali-dev; urgency=medium

  [ Raphaël Hertzog ]
  * Work around a bug breaking samba's build
  * Add some lintian overrides

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 17 Jul 2020 10:49:04 +0200

winexe (1.1~20140107-0kali9) kali-experimental; urgency=medium

  * Use "waf -j 1" for configure step

 -- Raphaël Hertzog <raphael@offensive-security.com>  Mon, 21 Oct 2019 17:17:02 +0200

winexe (1.1~20140107-0kali8) kali-experimental; urgency=medium

  * Switch to Python 3
  * Update waf for Python3
  * fix the build with new samba version
  * Add debian/source/lintian-overrides
  * Add a patch to fix spelling error
  * Bump Standards-Version to 4.4.1
  * Use debhelper-compat 12

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 07 Oct 2019 15:51:36 +0200

winexe (1.1~20140107-0kali7) kali-dev; urgency=medium

  * Add missing build-deps for the new version of samba: liblmdb-dev,
    libjansson-dev, libgpgme-dev, libarchive-dev

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 08 Nov 2018 14:16:57 +0100

winexe (1.1~20140107-0kali6) kali-dev; urgency=medium

  * Add missing build-dependency: libpam0g-dev

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 02 Nov 2017 11:23:02 +0100

winexe (1.1~20140107-0kali5) kali-dev; urgency=medium

  * No change rebuild.

 -- Raphaël Hertzog <buxy@kali.org>  Wed, 05 Jul 2017 15:36:55 +0200

winexe (1.1~20140107-0kali4) kali-dev; urgency=medium

  * Download samba at runtime and add another patch to work around
    headers dropped from the public headers available in Debian packages.

 -- Raphaël Hertzog <buxy@kali.org>  Wed, 18 May 2016 12:58:26 +0200

winexe (1.1~20140107-0kali3) kali-dev; urgency=medium

  * Add a patch to build against samba-libs version 4.3

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 01 Mar 2016 11:08:01 +0100

winexe (1.1~20140107-0kali2) kali-dev; urgency=medium

   * No change rebuild, just to increase the version number.

 -- Raphaël Hertzog <buxy@kali.org>  Mon, 31 Aug 2015 12:00:27 +0200

winexe (1.1~20140107-0kali1) kali-dev; urgency=medium

  * New upstream release
  * Drop build-dependencies that have been merged into samba-dev/samba-libs.
  * Drop patch that has been merged upstream.

 -- Raphaël Hertzog <buxy@kali.org>  Thu, 07 Aug 2014 13:51:15 +0000

winexe (1.1~20130620-0kali5) kali; urgency=low

  * Do no ship /usr/bin/bin2c (FS#715).

 -- Raphaël Hertzog <buxy@kali.org>  Thu, 28 Nov 2013 13:49:36 +0100

winexe (1.1~20130620-0kali4) kali-dev; urgency=low

  * Replace python-samba Build-Depends by samba-common-bin which really
    contains the library required by libsamba-credentials0 in the
    current version of the samba 4.0 packages.
  * Enable verbose build logs and add -Wall to CFLAGS.
  * Add use-pkgconfig patch to use the proper CFLAGS when building
    winexe against Samba's shared libraries.

 -- Raphaël Hertzog <buxy@kali.org>  Fri, 28 Jun 2013 22:19:33 +0200

winexe (1.1~20130620-0kali3) kali-dev; urgency=low

  * Disable entirely hardening as other options also cause problems.

 -- Raphaël Hertzog <buxy@kali.org>  Thu, 20 Jun 2013 23:03:55 +0200

winexe (1.1~20130620-0kali2) kali-dev; urgency=low

  * Disable "relro" hardening option as /usr/bin/x86_64-w64-mingw32-ld doesn't
    support the "-Wl,-z,relro" option.



=== debian/control ===
Source: winexe
Section: net
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends:
 debhelper-compat (= 12),
 gcc-mingw-w64,
 libpopt-dev,
 libtalloc-dev,
 libtevent-dev,
 pkg-config,
 samba-common-bin,
 samba-dev,
 libpam0g-dev,
# Needed to configure samba
 bison,
 flex,
 gnutls-dev,
 libacl1-dev,
 libldap-dev,
 liblmdb-dev,
 libjansson-dev,
 libgpgme-dev,
 libparse-yapp-perl,
 libdbus-1-dev,
 libarchive-dev,
 libjson-perl,
 libkeyutils-dev,
 python3-dev,
 python3-dnspython,
 python3-markdown,
Standards-Version: 4.6.2
Homepage: https://sourceforge.net/projects/winexe

Package: winexe
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Remote Windows-command executor
 Winexe remotely executes commands on Windows NT/2000/XP/2003 systems from
 GNU/Linux (and possibly also from other Unices capable of building the Samba 4
 software package).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=-all
export DEB_CFLAGS_MAINT_APPEND := -D__STDC_WANT_LIB_EXT1__=1

# For waf to make include path ordering fixed
# https://lists.samba.org/archive/samba-technical/2022-March/137230.html
# https://bugzilla.samba.org/show_bug.cgi?id=15033
export PYTHONHASHSEED := 1

# for some reason these platforms fail to find __atomic_{load,store}_8
# include a rough workaround for now, drop it when we know better, cf.
# https://salsa.debian.org/samba-team/samba/-/commit/338dccf8
include /usr/share/dpkg/architecture.mk
ifneq (,$(filter armel,${DEB_HOST_ARCH}))
LDFLAGS := ${LDFLAGS} -Wl,--as-needed -latomic
endif

SAMBA_LIBDIR := $(shell pkg-config --variable libdir samba-util)/samba
SAMBA_INCDIR := $(shell pkg-config --variable includedir samba-util)

empty :=
space := $(empty) $(empty)
samba_inc_dirs := \
	$(SAMBA_INCDIR) \
	$(CURDIR)/samba/source4 \
	$(CURDIR)/samba \
	$(CURDIR)/samba/bin/default/source \
	$(CURDIR)/samba/bin/default \
	$(CURDIR)/samba/lib/replace \
	$(CURDIR)/samba/lib \
	$(CURDIR)/samba/bin/default/include
samba_conf_args := \
	--prefix=/usr \
	--samba-lib-dirs=$(SAMBA_LIBDIR) \
	--samba-inc-dirs="$(subst $(space),:,$(strip $(samba_inc_dirs)))"

%:
	dh $@

override_dh_auto_clean:
	cd source && ./waf distclean
	rm -rf samba_* samba-* samba

override_dh_auto_configure:
	apt-get source samba
	ln -sf samba-* samba
	cd samba && ./buildtools/bin/waf -j 1 configure
	cd samba && ./buildtools/bin/waf build
	cd source && ./waf -j 1 configure $(samba_conf_args)

override_dh_auto_build:
	cd source && ./waf build --verbose

override_dh_auto_install:
	cd source && ./waf install --destdir $(CURDIR)/debian/winexe
	# bin2c is only useful at build time, and should not be installed
	# because it conflicts with nvidia-cuda-toolkit's one
	rm -f $(CURDIR)/debian/winexe/usr/bin/bin2c

=== debian/tests/control ===
Test-Command: winexe -h
Restrictions: allow-stderr, superficial

=== debian/watch ===
version=4
opts=searchmode=plain \
https://sourceforge.net/projects/winexe/rss?limit=10000000000000000000 \
https?://.*/winexe-(\d.*)\.tar\.gz

## winexe 1.1.1637016647.0a8fb93

=== source/wscript ===
#!/usr/bin/env python

import os

top = '.'
out = 'build'
AR32 = ['i386', 'i586', 'i686']
AR64 = ['x86_64', 'amd64']
TC = ['mingw32', 'mingw32msvc', 'w64-mingw32']

def options(ctx):
    ctx.load('compiler_c')
    g = ctx.get_option_group('configure options')
    g.add_option('--samba-dir', action='store', help='build winexe against the Samba source code tree at the given location instead of building it against Samba headers and shared libraries installed in standard locations', dest='SAMBA_DIR')
    g.add_option('--enable-shared', action='store_true', default=False, help='build winexe against Samba headers and shared libraries installed in standard locations in addition to building winexe statically when the samba-dir option is given', dest='ENABLE_SHARED')
    g.add_option('--samba-inc-dirs', action='store', help='build against Samba headers in the given location', dest='SAMBA_INCS')
    g.add_option('--samba-lib-dirs', action='store', help='build against Samba shared libraries in the given location (which will be added to the rpath) in addition to shared libraries on the default path; default is /usr/lib/x86_64-linux-gnu/samba', dest='SAMBA_LIBS')

def distclean(ctx):
    try:
        SAMBA_DIR = os.path.abspath(os.readlink('smb_static/.lock-wscript') + '/..')
        os.system('cd smb_static && ' + SAMBA_DIR + '/buildtools/bin/waf distclean')
    except:
        pass
    import waflib.Scripting
    waflib.Scripting.distclean(ctx)

def configure(ctx):
    ctx.load('compiler_c')

    if ctx.options.SAMBA_DIR:
        ctx.env.SAMBA_DIR = os.path.abspath(ctx.options.SAMBA_DIR)
        waf = ctx.env.SAMBA_DIR + '/buildtools/bin/waf'
        ctx.find_program(waf)
        if not os.path.exists('smb_static/build/libsmb_static.a'):
            os.system('cd smb_static && %s configure --bundled-libraries=ALL && %s --targets=smb_static' % (waf, waf))
        if ctx.options.ENABLE_SHARED:
            ctx.env.ENABLE_SHARED = True
        else:
            ctx.env.ENABLE_SHARED = False
    else:
        ctx.env.ENABLE_SHARED = True

    if ctx.env.ENABLE_SHARED:
        ctx.check_cfg(package='dcerpc', uselib_store='DCERPC', args=['--cflags', '--libs'])
        ctx.check_cfg(package='talloc', uselib_store='TALLOC', args=['--cflags', '--libs'])
        if ctx.options.SAMBA_INCS:
            ctx.env.SAMBA_INCS = ctx.options.SAMBA_INCS
        else:
            ctx.env.SAMBA_INCS = '/usr/include/samba-4.0'
        ctx.msg('SAMBA_INCS set to', ctx.env.SAMBA_INCS)

        if ctx.options.SAMBA_LIBS:
            ctx.env.SAMBA_LIBS = ctx.options.SAMBA_LIBS
        else:
            import subprocess
            for subdir in 'samba private'.split():
                p = subprocess.Popen(['gcc', '-print-file-name=%s/libcli-ldap.so' % (subdir)], stdout=subprocess.PIPE).communicate()[0].rstrip()
                if not os.path.exists(p):
                    p = subprocess.Popen(['gcc', '-print-file-name=%s/libcli-ldap.so.0' % (subdir)], stdout=subprocess.PIPE).communicate()[0].rstrip()
                if not os.path.exists(p):
                    continue
                ctx.env.SAMBA_LIBS = os.path.abspath(p + '/..')
                break
        ctx.msg('SAMBA_LIBS set to', ctx.env.SAMBA_LIBS)

        try:
            for h in 'samba_util.h core/error.h credentials.h dcerpc.h gen_ndr/ndr_svcctl_c.h popt.h smb_cli.h smb_cliraw.h smb_composite.h tevent.h util/debug.h'.split():
                ctx.check(includes=ctx.env.SAMBA_INCS, msg='Checking for ' + h, fragment='''
                #include <stdint.h>
                #include <stdbool.h>
                #if %d
                #include <samba_util.h>
                #include <core/error.h>
                #endif
                #include <%s>
                int main() {return 0;}
                ''' % (h in 'smb_cli.h smb_cliraw.h smb_composite.h util/debug.h'.split(), h))

            libs = []
            for l in 'cli-ldap dcerpc dcerpc-samba errors popt talloc ndr-standard samba-hostconfig samba-credentials smbclient-raw'.split():
                if ctx.check(lib=l, libpath=ctx.env.SAMBA_LIBS, mandatory=False):
                    libs.append(l)
                else:
                    ctx.check(lib=':lib'+l+'.so.0', libpath=ctx.env.SAMBA_LIBS)
                    libs.append(':lib'+l+'.so.0')
            ctx.env.LIBS = ' '.join(libs)
        except:
            ctx.msg('Build of shared winexe', 'disabled', 'YELLOW')
            ctx.env.ENABLE_SHARED = False

    if ctx.env.SAMBA_DIR:
        try:
            for l in 'smb_static popt com_err bsd z resolv rt dl'.split():
               ctx.check(lib=l, libpath=ctx.srcnode.abspath() + '/smb_static/build')
        except:
            ctx.msg('Build of static winexe', 'disabled', 'YELLOW')
            ctx.env.SAMBA_DIR = None

    if not ctx.env.ENABLE_SHARED and not ctx.env.SAMBA_DIR:
        ctx.fatal('Cannot continue! Please either install Samba shared libraries and re-run waf, or download the Samba source code and re-run waf with the "--samba-dir" option.')

    ctx.setenv('win32', ctx.env)
    ctx.find_program([ a + '-' + t + '-gcc' for a in AR32 for t in TC], var='CC_WIN32')
    ctx.env.update({"CC": ctx.env.CC_WIN32, "LINK_CC": ctx.env.CC_WIN32})

    ctx.setenv('win64', ctx.env)
    ctx.find_program([ a + '-' + t + '-gcc' for a in AR64 for t in TC], var='CC_WIN64')
    ctx.env.update({"CC": ctx.env.CC_WIN64, "LINK_CC": ctx.env.CC_WIN64})

=== source/smb_static/wscript ===
#!/usr/bin/env python

import sys, os

SCRIPT_DIR = os.path.abspath('.')
SAMBA_DIR = os.path.abspath(sys.argv[0] + '/../../..')

LOCK_FILE = '.lock-wscript'
try:
    os.unlink(LOCK_FILE)
except:
    pass
os.symlink(SAMBA_DIR + '/' + LOCK_FILE, LOCK_FILE)

os.chdir(SAMBA_DIR)
execfile("wscript")
Options.launch_dir = os.getcwd()
Options.SCRIPT_DIR = SCRIPT_DIR
Options.BUILD_DIR = Options.SCRIPT_DIR + '/build'

def distclean(ctx):
    try:
        import shutil
        shutil.rmtree(Options.BUILD_DIR, ignore_errors=True)
        os.unlink(Options.SCRIPT_DIR + '/' + LOCK_FILE)
    except:
        pass
    import Scripting
    Scripting.distclean(ctx)

from TaskGen import feature, after
@feature('patch_bldpath')
@after('apply_link')
def patch_bldpath(self):
    t = self.link_task.outputs[0]
    try:
        os.makedirs(Options.BUILD_DIR)
    except:
        pass
    p = Options.BUILD_DIR + '/' + t.file()
    t.bldpath = lambda e=None: p
    t.abspath = lambda e=None: p
    t.nice_path = lambda e=None: p
